/******************************************************************************************************

 Cerebrum.Vocabulary.Desktop.dll is part of the Morphology .NET toolkit and contains implementation of
 the toolkit user interface for the OOKBMS Cerebrum desktop environment.

 Copyright (C) 2007-2009 Shuklin Dmitry Evgenievich and Boyko Sergey Vasilievich. All rights reserved.

 The Morphology .NET toolkit is free software; you can redistribute it and/or modify it under the terms 
 of the Microsoft Public License (Ms-PL) as published by the Microsoft.

 This toolkit is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even 
 the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. THE ENTIRE RISK AS TO THE 
 QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU. SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE 
 COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.

 See the Microsoft Public License (Ms-PL) for more details.

 You should have received a copy of the Microsoft Public License (Ms-PL) along with this toolkit;
 if not, the Microsoft Public License (Ms-PL) can be found at 
 http://www.microsoft.com/opensource/licenses.mspx#Ms-PL

 Please see the LICENSE.txt file for the full license.

 For all inquieries and concerns contact an authors at  cerebrum@shdsoft.ru

 This copyright notice MUST APPEAR in all copies of this file!

 //////////////////////////////////////////////////////////////////////////////////////////////////////

  Cerebrum.Vocabulary.Desktop.dll -   Morphology .NET toolkit  
          Cerebrum.

 Copyright (C) 2007-2009       .   .

      ;     / 
      Microsoft Public License (Ms-PL).

     ,    ,   - ;
           .  
          .    
 ,        ,   
 .

      Microsoft Public License (Ms-PL)

      Microsoft Public License (Ms-PL)    ; 
   ,  Microsoft Public License (Ms-PL)      
 http://www.microsoft.com/opensource/licenses.mspx#Ms-PL 

       LICENSE.txt

          : cerebrum@shdsoft.ru
 
          !
 
******************************************************************************************************/

using System;

namespace Cerebrum.WorkWithFormsOfDatabases
{
	/// <summary>
	/// Summary description for CreateAndOpenDB.
	/// </summary>
	public class CreateAndOpenDB
	{
		public CreateAndOpenDB()
		{
		}

		/// <summary>
		///       -.
		/// </summary>
		/// <param name="application"></param>
		/// <param name="DomainName"> .</param>
		/// <param name="TemplateFileForCreateDB"> -.</param>
		/// <returns>DomainContext   .</returns>
		public static Cerebrum.Integrator.DomainContext CreateDocument(Cerebrum.Windows.Forms.Application application, string DomainName, string TemplateFileForCreateDB)
		{
			//Cerebrum.Windows.Forms.Application application = Cerebrum.Windows.Forms.Application.Instance;
			//Cerebrum.Windows.Forms.CreateDatabase dlg = new Cerebrum.Windows.Forms.CreateDatabase(Cerebrum.Windows.Forms.CreateDatabaseOptions.ClusterSize | Cerebrum.Windows.Forms.CreateDatabaseOptions.Versioning);
			Cerebrum.Windows.Forms.CreateDatabase dlg = new Cerebrum.Windows.Forms.CreateDatabase(Cerebrum.Windows.Forms.CreateDatabaseOptions.None);
			dlg.ClusterFrameSize = 4;
			dlg.Versioning = false;
			if(dlg.ShowDialog(application.PrimaryWindow)==System.Windows.Forms.DialogResult.OK)
			{
				//string bcfg = System.IO.Path.Combine(System.IO.Path.GetDirectoryName(typeof(AppUiService).Assembly.Location), TemplateFileForCreateDB);
				string bcfg = TemplateFileForCreateDB;
				
				Cerebrum.Integrator.IContextFactory lcs = new Cerebrum.Management.SimpleContextFactory(application, dlg.ClusterFileName, null, dlg.ClusterFrameSize, dlg.Versioning, bcfg, true);

				//lcs.DatabaseFileName = dlg.ClusterFileName;

				//lcs.InitContextDebug(c);
				Cerebrum.IWorkspace domain = lcs.InitContext(dlg.ClusterFileName, DomainName);
				Cerebrum.Integrator.DomainContext c = domain.Component as Cerebrum.Integrator.DomainContext;
				application.AddDomain(c);

				lcs.ImportDatabase(c, true);
				return c;
			}
			return null;
		}

		/// <summary>
		///   .
		/// </summary>
		/// <param name="argument"></param>
		/// <returns>DomainContext   .</returns>
		public static Cerebrum.Integrator.DomainContext OpenDocument(object argument)
		{
			Cerebrum.Integrator.DomainContext c = null;
			if(argument is Cerebrum.Integrator.DomainContextEventArgs)
			{
				c = (argument as Cerebrum.Integrator.DomainContextEventArgs).DomainContext;
			}
			else
			{
				System.Windows.Forms.OpenFileDialog dlg = new System.Windows.Forms.OpenFileDialog();
				dlg.DefaultExt = "vnn";
				dlg.Filter = "Cerebrum Database files|*.vnn|All files|*.*";
				if(dlg.ShowDialog(Cerebrum.Windows.Forms.Application.Instance.PrimaryWindow)==System.Windows.Forms.DialogResult.OK)
				{
					int mode = 0;
					if(dlg.FilterIndex==1)
					{
						mode = 1;
					}
					/*if(dlg.FilterIndex==2)
							{
								mode = 2;
							}*/
					if(mode==0)
					{
						string ext = System.IO.Path.GetExtension(dlg.FileName).ToLower();
						if(ext==".vnn")
						{
							mode = 1;
						}
						/*if(ext==".vnn")
								{
									mode = 2;
								}*/
					}
					/*if(mode==1)
							{
								OpenSource(dlg.FileName);
							}*/
					if(mode==1)
					{
						c = OpenDocument(dlg.FileName);
					}
				}
			}
			return c;
		}

		/// <summary>
		///   .
		/// </summary>
		/// <param name="FileName">   .</param>
		/// <param name="FilePath">   .</param>
		/// <returns>DomainContext   .</returns>
		public static Cerebrum.Integrator.DomainContext OpenDocument(string FileName, string FilePath)
		{
			Cerebrum.Integrator.DomainContext dc = null;
			string[] Files = System.IO.Directory.GetFiles(FilePath);
			System.Collections.ArrayList al = new System.Collections.ArrayList(Files);
			if(al.Contains(FilePath + @"\" + FileName) == true)
			{
				dc = OpenDocument(FilePath + @"\" + FileName);
			}
			return dc;
		}

		/// <summary>
		///   .
		/// </summary>
		/// <param name="DBPath">   .</param>
		/// <returns>DomainContext   .</returns>
		public static Cerebrum.Integrator.DomainContext OpenDocument(string DBPath)
		{
			Cerebrum.Integrator.DomainContext dc = null;
			Cerebrum.Windows.Forms.Application application = Cerebrum.Windows.Forms.Application.Instance;
			Cerebrum.Integrator.IContextFactory lcs = new Cerebrum.Management.SimpleContextFactory(application, DBPath, null, 4, true, "", false);
			Cerebrum.IWorkspace domain = lcs.LoadContext(DBPath);
			dc = domain.Component as Cerebrum.Integrator.DomainContext;
			application.AddDomain(dc);
			return dc;
		}
	}
}
