/******************************************************************************************************

 Cerebrum.Vocabulary.Desktop.dll is part of the Morphology .NET toolkit and contains implementation of
 the toolkit user interface for the OOKBMS Cerebrum desktop environment.

 Copyright (C) 2007-2009 Shuklin Dmitry Evgenievich and Boyko Sergey Vasilievich. All rights reserved.

 The Morphology .NET toolkit is free software; you can redistribute it and/or modify it under the terms 
 of the Microsoft Public License (Ms-PL) as published by the Microsoft.

 This toolkit is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even 
 the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. THE ENTIRE RISK AS TO THE 
 QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU. SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE 
 COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.

 See the Microsoft Public License (Ms-PL) for more details.

 You should have received a copy of the Microsoft Public License (Ms-PL) along with this toolkit;
 if not, the Microsoft Public License (Ms-PL) can be found at 
 http://www.microsoft.com/opensource/licenses.mspx#Ms-PL

 Please see the LICENSE.txt file for the full license.

 For all inquieries and concerns contact an authors at  cerebrum@shdsoft.ru

 This copyright notice MUST APPEAR in all copies of this file!

 //////////////////////////////////////////////////////////////////////////////////////////////////////

  Cerebrum.Vocabulary.Desktop.dll -   Morphology .NET toolkit  
          Cerebrum.

 Copyright (C) 2007-2009       .   .

      ;     / 
      Microsoft Public License (Ms-PL).

     ,    ,   - ;
           .  
          .    
 ,        ,   
 .

      Microsoft Public License (Ms-PL)

      Microsoft Public License (Ms-PL)    ; 
   ,  Microsoft Public License (Ms-PL)      
 http://www.microsoft.com/opensource/licenses.mspx#Ms-PL 

       LICENSE.txt

          : cerebrum@shdsoft.ru
 
          !
 
******************************************************************************************************/

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace Cerebrum.Vocabulary.Desktop
{
	/// <summary>
	/// Summary description for ExportCSVForm.
	/// </summary>
	public class ExportCSVForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.CheckBox chkBoxAttributes;
		private System.Windows.Forms.CheckBox chkBoxSpecifiers;
		private System.Windows.Forms.CheckBox chkBoxTransforms;
		private System.Windows.Forms.CheckBox chkBoxStatements;
		private System.Windows.Forms.CheckBox chkBoxEnding;
		private System.Windows.Forms.Button btnOK;
		private System.Windows.Forms.Button btnCancel;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public ExportCSVForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.chkBoxAttributes = new System.Windows.Forms.CheckBox();
			this.chkBoxSpecifiers = new System.Windows.Forms.CheckBox();
			this.chkBoxTransforms = new System.Windows.Forms.CheckBox();
			this.chkBoxStatements = new System.Windows.Forms.CheckBox();
			this.chkBoxEnding = new System.Windows.Forms.CheckBox();
			this.btnOK = new System.Windows.Forms.Button();
			this.btnCancel = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// chkBoxAttributes
			// 
			this.chkBoxAttributes.Checked = true;
			this.chkBoxAttributes.CheckState = System.Windows.Forms.CheckState.Checked;
			this.chkBoxAttributes.Location = new System.Drawing.Point(8, 8);
			this.chkBoxAttributes.Name = "chkBoxAttributes";
			this.chkBoxAttributes.TabIndex = 0;
			this.chkBoxAttributes.Text = "Attributes";
			// 
			// chkBoxSpecifiers
			// 
			this.chkBoxSpecifiers.Checked = true;
			this.chkBoxSpecifiers.CheckState = System.Windows.Forms.CheckState.Checked;
			this.chkBoxSpecifiers.Location = new System.Drawing.Point(120, 8);
			this.chkBoxSpecifiers.Name = "chkBoxSpecifiers";
			this.chkBoxSpecifiers.TabIndex = 1;
			this.chkBoxSpecifiers.Text = "Specifiers";
			// 
			// chkBoxTransforms
			// 
			this.chkBoxTransforms.Checked = true;
			this.chkBoxTransforms.CheckState = System.Windows.Forms.CheckState.Checked;
			this.chkBoxTransforms.Location = new System.Drawing.Point(232, 8);
			this.chkBoxTransforms.Name = "chkBoxTransforms";
			this.chkBoxTransforms.TabIndex = 2;
			this.chkBoxTransforms.Text = "Transforms";
			// 
			// chkBoxStatements
			// 
			this.chkBoxStatements.Checked = true;
			this.chkBoxStatements.CheckState = System.Windows.Forms.CheckState.Checked;
			this.chkBoxStatements.Location = new System.Drawing.Point(344, 8);
			this.chkBoxStatements.Name = "chkBoxStatements";
			this.chkBoxStatements.TabIndex = 3;
			this.chkBoxStatements.Text = "Statements";
			// 
			// chkBoxEnding
			// 
			this.chkBoxEnding.Checked = true;
			this.chkBoxEnding.CheckState = System.Windows.Forms.CheckState.Checked;
			this.chkBoxEnding.Location = new System.Drawing.Point(8, 40);
			this.chkBoxEnding.Name = "chkBoxEnding";
			this.chkBoxEnding.Size = new System.Drawing.Size(272, 24);
			this.chkBoxEnding.TabIndex = 4;
			this.chkBoxEnding.Text = "Append the flexias to statements";
			// 
			// btnOK
			// 
			this.btnOK.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.btnOK.Location = new System.Drawing.Point(296, 40);
			this.btnOK.Name = "btnOK";
			this.btnOK.TabIndex = 5;
			this.btnOK.Text = "OK";
			// 
			// btnCancel
			// 
			this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.btnCancel.Location = new System.Drawing.Point(376, 40);
			this.btnCancel.Name = "btnCancel";
			this.btnCancel.TabIndex = 6;
			this.btnCancel.Text = "Cancel";
			// 
			// ExportCSVForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(456, 69);
			this.Controls.Add(this.btnCancel);
			this.Controls.Add(this.btnOK);
			this.Controls.Add(this.chkBoxEnding);
			this.Controls.Add(this.chkBoxStatements);
			this.Controls.Add(this.chkBoxTransforms);
			this.Controls.Add(this.chkBoxSpecifiers);
			this.Controls.Add(this.chkBoxAttributes);
			this.Name = "ExportCSVForm";
			this.ShowInTaskbar = false;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Export";
			this.ResumeLayout(false);

		}
		#endregion

		public bool IsExportAttributes
		{
			get
			{
				return chkBoxAttributes.Checked;
			}
		}

		public bool IsExportSpecifiers
		{
			get
			{
				return chkBoxSpecifiers.Checked;
			}
		}

		public bool IsExportTransforms
		{
			get
			{
				return chkBoxTransforms.Checked;
			}
		}

		public bool IsExportStatements
		{
			get
			{
				return chkBoxStatements.Checked;
			}
		}

		public bool IsAddEndings
		{
			get
			{
				return chkBoxEnding.Checked;
			}
		}
	}
}
