/******************************************************************************************************

 Cerebrum.Vocabulary.Desktop.dll is part of the Morphology .NET toolkit and contains implementation of
 the toolkit user interface for the OOKBMS Cerebrum desktop environment.

 Copyright (C) 2007-2009 Shuklin Dmitry Evgenievich and Boyko Sergey Vasilievich. All rights reserved.

 The Morphology .NET toolkit is free software; you can redistribute it and/or modify it under the terms 
 of the Microsoft Public License (Ms-PL) as published by the Microsoft.

 This toolkit is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even 
 the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. THE ENTIRE RISK AS TO THE 
 QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU. SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE 
 COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.

 See the Microsoft Public License (Ms-PL) for more details.

 You should have received a copy of the Microsoft Public License (Ms-PL) along with this toolkit;
 if not, the Microsoft Public License (Ms-PL) can be found at 
 http://www.microsoft.com/opensource/licenses.mspx#Ms-PL

 Please see the LICENSE.txt file for the full license.

 For all inquieries and concerns contact an authors at  cerebrum@shdsoft.ru

 This copyright notice MUST APPEAR in all copies of this file!

 //////////////////////////////////////////////////////////////////////////////////////////////////////

  Cerebrum.Vocabulary.Desktop.dll -   Morphology .NET toolkit  
          Cerebrum.

 Copyright (C) 2007-2009       .   .

      ;     / 
      Microsoft Public License (Ms-PL).

     ,    ,   - ;
           .  
          .    
 ,        ,   
 .

      Microsoft Public License (Ms-PL)

      Microsoft Public License (Ms-PL)    ; 
   ,  Microsoft Public License (Ms-PL)      
 http://www.microsoft.com/opensource/licenses.mspx#Ms-PL 

       LICENSE.txt

          : cerebrum@shdsoft.ru
 
          !
 
******************************************************************************************************/

using System;

namespace Cerebrum.Vocabulary.Desktop
{
	public enum FindFieldContains {FieldNameInCSV, AttributeName};

	/// <summary>
	/// Summary description for VectorsInfo.
	/// </summary>
	public class FieldsInfo
	{
		private System.Collections.ArrayList m_FieldsInfo;

		public FieldsInfo()
		{
			m_FieldsInfo = new System.Collections.ArrayList();
		}

		public FieldInfo Add(FieldInfo vi)
		{
			m_FieldsInfo.Add(vi);
			return (FieldInfo)m_FieldsInfo[m_FieldsInfo.Count - 1];
		}

		public FieldInfo this[int index]
		{
			set
			{
				m_FieldsInfo[index] = value;
			}
			get
			{
				return (FieldInfo)m_FieldsInfo[index];
			}
		}

		public int Count
		{
			get
			{
				return m_FieldsInfo.Count;
			}
		}

		public int FindIndex(string val, FindFieldContains ffc)
		{
			int index = -1;
			string val1 = "";

			for(int i=0; i<m_FieldsInfo.Count; i++)
			{
				FieldInfo vi = (FieldInfo)m_FieldsInfo[i];

				if(ffc == FindFieldContains.AttributeName)
				{
					val1 = vi.AttributeName;
				}
				else if(ffc == FindFieldContains.FieldNameInCSV)
				{
					val1 = vi.FieldNameInCSV;
				}

				if(val1 == val)
				{
					index = i;
					break;
				}
			}
			return index;
		}

		public FieldInfo FindFieldInfo(string val, FindFieldContains ffc)
		{
			FieldInfo vi = null;

			int index = FindIndex(val, ffc);
			if(index >= 0)
			{
				vi = (FieldInfo)m_FieldsInfo[index];
			}
			return vi;
		}

		public bool Contains(FieldInfo vi)
		{
			return m_FieldsInfo.Contains(vi);
		}

		public bool Contains(string val, FindFieldContains ffc)
		{
			bool res = false;
			string val1 = "";

			for(int i=0; i<m_FieldsInfo.Count; i++)
			{
				FieldInfo vi = (FieldInfo)m_FieldsInfo[i];
				if(ffc == FindFieldContains.AttributeName)
				{
					val1 = vi.AttributeName;
				}
				else if(ffc == FindFieldContains.FieldNameInCSV)
				{
					val1 = vi.FieldNameInCSV;
				}

				if(val1 == val)
				{
					res = true;
					break;
				}
			}
			return res;
		}

		public string GetAttributeName(string FieldNameInCSV)
		{
			string res = "";

			for(int i=0; i<m_FieldsInfo.Count; i++)
			{
				FieldInfo vi = (FieldInfo)m_FieldsInfo[i];
				if(vi.FieldNameInCSV == FieldNameInCSV)
				{
					res = vi.AttributeName;
					break;
				}
			}
			return res;
		}
	}
}
