/******************************************************************************************************

 Cerebrum.Vocabulary.Desktop.dll is part of the Morphology .NET toolkit and contains implementation of
 the toolkit user interface for the OOKBMS Cerebrum desktop environment.

 Copyright (C) 2007-2009 Shuklin Dmitry Evgenievich and Boyko Sergey Vasilievich. All rights reserved.

 The Morphology .NET toolkit is free software; you can redistribute it and/or modify it under the terms 
 of the Microsoft Public License (Ms-PL) as published by the Microsoft.

 This toolkit is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even 
 the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. THE ENTIRE RISK AS TO THE 
 QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU. SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE 
 COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.

 See the Microsoft Public License (Ms-PL) for more details.

 You should have received a copy of the Microsoft Public License (Ms-PL) along with this toolkit;
 if not, the Microsoft Public License (Ms-PL) can be found at 
 http://www.microsoft.com/opensource/licenses.mspx#Ms-PL

 Please see the LICENSE.txt file for the full license.

 For all inquieries and concerns contact an authors at  cerebrum@shdsoft.ru

 This copyright notice MUST APPEAR in all copies of this file!

 //////////////////////////////////////////////////////////////////////////////////////////////////////

  Cerebrum.Vocabulary.Desktop.dll -   Morphology .NET toolkit  
          Cerebrum.

 Copyright (C) 2007-2009       .   .

      ;     / 
      Microsoft Public License (Ms-PL).

     ,    ,   - ;
           .  
          .    
 ,        ,   
 .

      Microsoft Public License (Ms-PL)

      Microsoft Public License (Ms-PL)    ; 
   ,  Microsoft Public License (Ms-PL)      
 http://www.microsoft.com/opensource/licenses.mspx#Ms-PL 

       LICENSE.txt

          : cerebrum@shdsoft.ru
 
          !
 
******************************************************************************************************/

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace Cerebrum.Vocabulary.Desktop
{
	/// <summary>
	/// Summary description for ImportCSVForm.
	/// </summary>
	public class ImportCSVForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TextBox textBoxAttributes;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Button btnAttributes;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Button btnOK;
		private System.Windows.Forms.Button btnCancel;
		private System.Windows.Forms.Button btnSpecifiers;
		private System.Windows.Forms.TextBox textBoxSpecifiers;
		private System.Windows.Forms.Button btnTransforms;
		private System.Windows.Forms.TextBox textBoxTransforms;
		private System.Windows.Forms.Button btnStatements;
		private System.Windows.Forms.TextBox textBoxStatements;
		private Cerebrum.Vocabulary.VocabularyDatabaseForm dbForm;
		private System.Windows.Forms.CheckBox chkWordStructureSensitive;
		private System.Windows.Forms.CheckBox chkProcessFlexias;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public ImportCSVForm(Cerebrum.Vocabulary.VocabularyDatabaseForm dbform)
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			dbForm = dbform;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.textBoxAttributes = new System.Windows.Forms.TextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.btnAttributes = new System.Windows.Forms.Button();
			this.btnSpecifiers = new System.Windows.Forms.Button();
			this.label2 = new System.Windows.Forms.Label();
			this.textBoxSpecifiers = new System.Windows.Forms.TextBox();
			this.btnTransforms = new System.Windows.Forms.Button();
			this.label3 = new System.Windows.Forms.Label();
			this.textBoxTransforms = new System.Windows.Forms.TextBox();
			this.btnStatements = new System.Windows.Forms.Button();
			this.label4 = new System.Windows.Forms.Label();
			this.textBoxStatements = new System.Windows.Forms.TextBox();
			this.btnOK = new System.Windows.Forms.Button();
			this.btnCancel = new System.Windows.Forms.Button();
			this.chkProcessFlexias = new System.Windows.Forms.CheckBox();
			this.chkWordStructureSensitive = new System.Windows.Forms.CheckBox();
			this.SuspendLayout();
			// 
			// textBoxAttributes
			// 
			this.textBoxAttributes.Location = new System.Drawing.Point(88, 8);
			this.textBoxAttributes.Name = "textBoxAttributes";
			this.textBoxAttributes.Size = new System.Drawing.Size(488, 20);
			this.textBoxAttributes.TabIndex = 0;
			this.textBoxAttributes.Text = "";
			this.textBoxAttributes.TextChanged += new System.EventHandler(this.textBoxAttributes_TextChanged);
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 8);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(56, 20);
			this.label1.TabIndex = 1;
			this.label1.Text = "Attributes:";
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// btnAttributes
			// 
			this.btnAttributes.Location = new System.Drawing.Point(584, 8);
			this.btnAttributes.Name = "btnAttributes";
			this.btnAttributes.Size = new System.Drawing.Size(24, 20);
			this.btnAttributes.TabIndex = 1;
			this.btnAttributes.Text = "...";
			this.btnAttributes.Click += new System.EventHandler(this.btnAttributes_Click);
			// 
			// btnSpecifiers
			// 
			this.btnSpecifiers.Location = new System.Drawing.Point(584, 32);
			this.btnSpecifiers.Name = "btnSpecifiers";
			this.btnSpecifiers.Size = new System.Drawing.Size(24, 20);
			this.btnSpecifiers.TabIndex = 3;
			this.btnSpecifiers.Text = "...";
			this.btnSpecifiers.Click += new System.EventHandler(this.btnSpecifiers_Click);
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(8, 32);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(64, 20);
			this.label2.TabIndex = 4;
			this.label2.Text = "Specifiers:";
			this.label2.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// textBoxSpecifiers
			// 
			this.textBoxSpecifiers.Location = new System.Drawing.Point(88, 32);
			this.textBoxSpecifiers.Name = "textBoxSpecifiers";
			this.textBoxSpecifiers.Size = new System.Drawing.Size(488, 20);
			this.textBoxSpecifiers.TabIndex = 2;
			this.textBoxSpecifiers.Text = "";
			this.textBoxSpecifiers.TextChanged += new System.EventHandler(this.textBoxSpecifiers_TextChanged);
			// 
			// btnTransforms
			// 
			this.btnTransforms.Location = new System.Drawing.Point(584, 56);
			this.btnTransforms.Name = "btnTransforms";
			this.btnTransforms.Size = new System.Drawing.Size(24, 20);
			this.btnTransforms.TabIndex = 5;
			this.btnTransforms.Text = "...";
			this.btnTransforms.Click += new System.EventHandler(this.btnTransforms_Click);
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(8, 56);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(72, 20);
			this.label3.TabIndex = 7;
			this.label3.Text = "Transforms:";
			this.label3.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// textBoxTransforms
			// 
			this.textBoxTransforms.Location = new System.Drawing.Point(88, 56);
			this.textBoxTransforms.Name = "textBoxTransforms";
			this.textBoxTransforms.Size = new System.Drawing.Size(488, 20);
			this.textBoxTransforms.TabIndex = 4;
			this.textBoxTransforms.Text = "";
			this.textBoxTransforms.TextChanged += new System.EventHandler(this.textBoxTransforms_TextChanged);
			// 
			// btnStatements
			// 
			this.btnStatements.Location = new System.Drawing.Point(584, 80);
			this.btnStatements.Name = "btnStatements";
			this.btnStatements.Size = new System.Drawing.Size(24, 20);
			this.btnStatements.TabIndex = 7;
			this.btnStatements.Text = "...";
			this.btnStatements.Click += new System.EventHandler(this.btnStatements_Click);
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(8, 80);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(72, 20);
			this.label4.TabIndex = 10;
			this.label4.Text = "Statements:";
			this.label4.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// textBoxStatements
			// 
			this.textBoxStatements.Location = new System.Drawing.Point(88, 80);
			this.textBoxStatements.Name = "textBoxStatements";
			this.textBoxStatements.Size = new System.Drawing.Size(488, 20);
			this.textBoxStatements.TabIndex = 6;
			this.textBoxStatements.Text = "";
			this.textBoxStatements.TextChanged += new System.EventHandler(this.textBoxStatements_TextChanged);
			// 
			// btnOK
			// 
			this.btnOK.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.btnOK.Location = new System.Drawing.Point(456, 128);
			this.btnOK.Name = "btnOK";
			this.btnOK.TabIndex = 8;
			this.btnOK.Text = "OK";
			this.btnOK.Click += new System.EventHandler(this.btnOK_Click);
			// 
			// btnCancel
			// 
			this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.btnCancel.Location = new System.Drawing.Point(536, 128);
			this.btnCancel.Name = "btnCancel";
			this.btnCancel.TabIndex = 9;
			this.btnCancel.Text = "Cancel";
			// 
			// chkProcessFlexias
			// 
			this.chkProcessFlexias.CheckAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.chkProcessFlexias.Checked = true;
			this.chkProcessFlexias.CheckState = System.Windows.Forms.CheckState.Checked;
			this.chkProcessFlexias.Location = new System.Drawing.Point(8, 104);
			this.chkProcessFlexias.Name = "chkProcessFlexias";
			this.chkProcessFlexias.Size = new System.Drawing.Size(224, 24);
			this.chkProcessFlexias.TabIndex = 11;
			this.chkProcessFlexias.Text = "Process flexias when import statements";
			// 
			// chkWordStructureSensitive
			// 
			this.chkWordStructureSensitive.CheckAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.chkWordStructureSensitive.Checked = true;
			this.chkWordStructureSensitive.CheckState = System.Windows.Forms.CheckState.Checked;
			this.chkWordStructureSensitive.Location = new System.Drawing.Point(8, 128);
			this.chkWordStructureSensitive.Name = "chkWordStructureSensitive";
			this.chkWordStructureSensitive.Size = new System.Drawing.Size(224, 24);
			this.chkWordStructureSensitive.TabIndex = 12;
			this.chkWordStructureSensitive.Text = "Word structure sensitive import";
			// 
			// ImportCSVForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(618, 159);
			this.Controls.Add(this.chkWordStructureSensitive);
			this.Controls.Add(this.chkProcessFlexias);
			this.Controls.Add(this.btnCancel);
			this.Controls.Add(this.btnOK);
			this.Controls.Add(this.btnStatements);
			this.Controls.Add(this.label4);
			this.Controls.Add(this.textBoxStatements);
			this.Controls.Add(this.btnTransforms);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.textBoxTransforms);
			this.Controls.Add(this.btnSpecifiers);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.textBoxSpecifiers);
			this.Controls.Add(this.btnAttributes);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.textBoxAttributes);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.Name = "ImportCSVForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Import";
			this.Load += new System.EventHandler(this.ImportCSVForm_Load);
			this.ResumeLayout(false);

		}
		#endregion

		private void ImportCSVForm_Load(object sender, System.EventArgs e)
		{
			Validator();
		}

		private void btnAttributes_Click(object sender, System.EventArgs e)
		{
			textBoxAttributes.Text = SelectFile("*Attributes.csv", "*Attributes.csv|*Attributes.csv|*.at.csv|*.at.csv|*.*|*.*");
			Validator();
		}

		private void btnSpecifiers_Click(object sender, System.EventArgs e)
		{
			textBoxSpecifiers.Text = SelectFile("*Specifiers.csv", "*Specifiers.csv|*Specifiers.csv|*.sp.csv|*.sp.csv|*.*|*.*");
			Validator();
		}

		private void btnTransforms_Click(object sender, System.EventArgs e)
		{
			textBoxTransforms.Text = SelectFile("*Transforms.csv", "*Transforms.csv|*Transforms.csv|*.tr.csv|*.tr.csv|*.*|*.*");
			Validator();
		}

		private void btnStatements_Click(object sender, System.EventArgs e)
		{
			textBoxStatements.Text = SelectFile("*Statements.ini", "*Statements.ini|*Statements.ini|ZlStatements*.ini|ZlStatements*.ini|*.st.ini|*.st.ini|*.*|*.*");
			Validator();
		}

		private void btnOK_Click(object sender, System.EventArgs e)
		{
			Cerebrum.Vocabulary.Desktop.FileInfo fi = null;
			Cerebrum.Vocabulary.Desktop.ImportCSV import = null;

			try
			{
				bool stmntsdone = false, trnsfsdone = false;
				System.DateTime StartDT = System.DateTime.Now;
				import = new Cerebrum.Vocabulary.Desktop.ImportCSV(dbForm.DomainContext, dbForm.m_WMaster);
				if(textBoxAttributes.Text != "")
				{
					//  ZlAttributes.csv
					fi = WorkInFile.LoadFile(textBoxAttributes.Text);
					if(fi != null)
					{
						WorkInfo.ShowWindow(".   ZlAttributes.csv.", this.MdiParent);
						fi.FieldsInfo.Add(new Cerebrum.Vocabulary.Desktop.FieldInfo("Name", "Name", "", true, Cerebrum.Vocabulary.Desktop.WayOfDataRecording.Standard));
						fi.FieldsInfo.Add(new Cerebrum.Vocabulary.Desktop.FieldInfo("DisplayName", "DisplayName", "", true, Cerebrum.Vocabulary.Desktop.WayOfDataRecording.Standard));
						fi.FieldsInfo.Add(new Cerebrum.Vocabulary.Desktop.FieldInfo("Description", "Description", "", true, Cerebrum.Vocabulary.Desktop.WayOfDataRecording.Standard));
						import.ImportData("ZlAttributes", fi, "");
						WorkInfo.HideWindow();
						dbForm.SetStatusBarMessage(" ZlAttributes.csv .");
					}
					else
					{
						dbForm.SetStatusBarMessage(" ZlTAttributes.csv .");
					}
				}

				if(textBoxSpecifiers.Text != "")
				{
					//  ZlSpecifiers.csv
					fi = WorkInFile.LoadFile(textBoxSpecifiers.Text);
					if(fi != null)
					{
						WorkInfo.ShowWindow(".   ZlSpecifiers.csv.", this.MdiParent);
						fi.FieldsInfo.Add(new Cerebrum.Vocabulary.Desktop.FieldInfo("Attributes", "ZlAttributes", "ZlAttributes", true, Cerebrum.Vocabulary.Desktop.WayOfDataRecording.Vector));
						fi.FieldsInfo.Add(new Cerebrum.Vocabulary.Desktop.FieldInfo("Description", "Description", "", true, Cerebrum.Vocabulary.Desktop.WayOfDataRecording.Standard));
						import.ImportZlSpecifiers(fi);
						WorkInfo.HideWindow();
						dbForm.SetStatusBarMessage(" ZlSpecifiers.csv .");
					}
					else
					{
						dbForm.SetStatusBarMessage(" ZlSpecifiers.csv .");
					}
				}

				if(textBoxTransforms.Text != "")
				{
					//  ZlTransforms.csv
					fi = WorkInFile.LoadFile(textBoxTransforms.Text);
					if(fi != null)
					{
						WorkInfo.ShowWindow(".   ZlTransforms.csv.", this.MdiParent);
						fi.FieldsInfo.Add(new Cerebrum.Vocabulary.Desktop.FieldInfo("Name", "Name", "", true, Cerebrum.Vocabulary.Desktop.WayOfDataRecording.Standard));
						fi.FieldsInfo.Add(new Cerebrum.Vocabulary.Desktop.FieldInfo("Wordform", "WordBase", "ZlTransforms", true, Cerebrum.Vocabulary.Desktop.WayOfDataRecording.Indexing));
						fi.FieldsInfo.Add(new Cerebrum.Vocabulary.Desktop.FieldInfo("", "PrimarySpecifier", "ZlTransforms", true, Cerebrum.Vocabulary.Desktop.WayOfDataRecording.Standard));
						fi.FieldsInfo.Add(new Cerebrum.Vocabulary.Desktop.FieldInfo("Specifier", "", "ZlTransforms", false, Cerebrum.Vocabulary.Desktop.WayOfDataRecording.Standard));
						fi.FieldsInfo.Add(new Cerebrum.Vocabulary.Desktop.FieldInfo("Wordform", "", "ZlTransforms", false, Cerebrum.Vocabulary.Desktop.WayOfDataRecording.Standard));
						fi.FieldsInfo.Add(new Cerebrum.Vocabulary.Desktop.FieldInfo("Flexia", "", "ZlTransforms", false, Cerebrum.Vocabulary.Desktop.WayOfDataRecording.Standard));
						import.ImportZlTransforms(fi, chkWordStructureSensitive.Checked);
						WorkInfo.HideWindow();
						dbForm.SetStatusBarMessage(" ZlTransforms.csv .");
						trnsfsdone = true;
					}
					else
					{
						dbForm.SetStatusBarMessage(" ZlTransforms.csv .");
					}
				}

				if(textBoxStatements.Text != "")
				{
					//  ZlStatements.ini
					fi = WorkInFile.LoadFile(textBoxStatements.Text);
					if(fi != null)
					{
						WorkInfo.ShowWindow(".   ZlStatements.ini.", this.MdiParent);
						import.ImportZlStatements(fi, chkProcessFlexias.Checked, chkWordStructureSensitive.Checked);
						WorkInfo.HideWindow();
						dbForm.SetStatusBarMessage(" ZlStatements.ini .");
						stmntsdone = true;
					}
					else
					{
						dbForm.SetStatusBarMessage(" ZlStatements.ini .");
					}
				}

				if(stmntsdone)
				{
					Cerebrum.Data.TableView view = Cerebrum.Management.Utilites.GetView(dbForm.DomainContext, "ZlStatements");
					dbForm.m_DataGrid1.DataSource = view;
				}
				else if(trnsfsdone)
				{
					Cerebrum.Data.TableView view = Cerebrum.Management.Utilites.GetView(dbForm.DomainContext, "ZlTransforms");
					dbForm.m_DataGrid1.DataSource = view;
				}


				System.DateTime EndDT = System.DateTime.Now;
				MessageBox.Show("    " + (EndDT - StartDT).ToString());
			}
			catch (Exception ex)
			{
				Cerebrum.Windows.Forms.Application.Instance.ProcessException(ex, "");
			}
		}

		private void Validator()
		{
			if((textBoxAttributes.Text != "")&&(textBoxSpecifiers.Text != "")&&(textBoxTransforms.Text != "")&&(textBoxStatements.Text != ""))
			{
				btnOK.Enabled = true;
			}
			else if((textBoxAttributes.Text != "")&&(textBoxSpecifiers.Text != "")&&(textBoxTransforms.Text != ""))
			{
				btnOK.Enabled = true;
			}
			else if((textBoxTransforms.Text != "")&&(textBoxStatements.Text != ""))
			{
				btnOK.Enabled = true;
			}
			else if((textBoxAttributes.Text != "")&&(textBoxSpecifiers.Text != ""))
			{
				btnOK.Enabled = true;
			}
			if(textBoxAttributes.Text != "")
			{
				btnOK.Enabled = true;
			}
			if(textBoxSpecifiers.Text != "")
			{
				btnOK.Enabled = true;
			}
			if(textBoxTransforms.Text != "")
			{
				btnOK.Enabled = true;
			}
			if(textBoxStatements.Text != "")
			{
				btnOK.Enabled = true;
			}
		}

		private string SelectFile(string DefaultExt, string Filter)
		{
			string File = "";
			OpenFileDialog dlg = new OpenFileDialog();
			dlg.DefaultExt = DefaultExt;
			dlg.Filter = Filter;
			if (dlg.ShowDialog() == DialogResult.OK)
			{
				File = dlg.FileName;
			}
			return File;
		}

		private void textBoxAttributes_TextChanged(object sender, System.EventArgs e)
		{
			Validator();
		}

		private void textBoxSpecifiers_TextChanged(object sender, System.EventArgs e)
		{
			Validator();
		}

		private void textBoxTransforms_TextChanged(object sender, System.EventArgs e)
		{
			Validator();
		}

		private void textBoxStatements_TextChanged(object sender, System.EventArgs e)
		{
			Validator();
		}
	}
}
