/******************************************************************************************************

 Cerebrum.Vocabulary.Desktop.dll is part of the Morphology .NET toolkit and contains implementation of
 the toolkit user interface for the OOKBMS Cerebrum desktop environment.

 Copyright (C) 2007-2009 Shuklin Dmitry Evgenievich and Boyko Sergey Vasilievich. All rights reserved.

 The Morphology .NET toolkit is free software; you can redistribute it and/or modify it under the terms 
 of the Microsoft Public License (Ms-PL) as published by the Microsoft.

 This toolkit is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even 
 the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. THE ENTIRE RISK AS TO THE 
 QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU. SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE 
 COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.

 See the Microsoft Public License (Ms-PL) for more details.

 You should have received a copy of the Microsoft Public License (Ms-PL) along with this toolkit;
 if not, the Microsoft Public License (Ms-PL) can be found at 
 http://www.microsoft.com/opensource/licenses.mspx#Ms-PL

 Please see the LICENSE.txt file for the full license.

 For all inquieries and concerns contact an authors at  cerebrum@shdsoft.ru

 This copyright notice MUST APPEAR in all copies of this file!

 //////////////////////////////////////////////////////////////////////////////////////////////////////

  Cerebrum.Vocabulary.Desktop.dll -   Morphology .NET toolkit  
          Cerebrum.

 Copyright (C) 2007-2009       .   .

      ;     / 
      Microsoft Public License (Ms-PL).

     ,    ,   - ;
           .  
          .    
 ,        ,   
 .

      Microsoft Public License (Ms-PL)

      Microsoft Public License (Ms-PL)    ; 
   ,  Microsoft Public License (Ms-PL)      
 http://www.microsoft.com/opensource/licenses.mspx#Ms-PL 

       LICENSE.txt

          : cerebrum@shdsoft.ru
 
          !
 
******************************************************************************************************/

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace Cerebrum.Vocabulary.Desktop
{
	/// <summary>
	/// Summary description for ReportForm.
	/// </summary>
	public class ReportForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.ListView listView1;
		private System.Collections.ArrayList m_alReport;
		private string m_ReportFileName;
		private System.Windows.Forms.ColumnHeader columnHeader1;
		private System.Windows.Forms.Button button1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public ReportForm(System.Collections.ArrayList alReport)
		{
			// Required for Windows Form Designer support
			InitializeComponent();

			m_alReport = alReport;
			m_ReportFileName = "";
		}

		public ReportForm(System.Collections.ArrayList alReport, string ReportFileName)
		{
			// Required for Windows Form Designer support
			InitializeComponent();

			m_alReport = alReport;
			m_ReportFileName = ReportFileName;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.listView1 = new System.Windows.Forms.ListView();
			this.columnHeader1 = new System.Windows.Forms.ColumnHeader();
			this.button1 = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// listView1
			// 
			this.listView1.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																						this.columnHeader1});
			this.listView1.FullRowSelect = true;
			this.listView1.GridLines = true;
			this.listView1.HoverSelection = true;
			this.listView1.Location = new System.Drawing.Point(8, 40);
			this.listView1.MultiSelect = false;
			this.listView1.Name = "listView1";
			this.listView1.Size = new System.Drawing.Size(656, 392);
			this.listView1.TabIndex = 0;
			this.listView1.View = System.Windows.Forms.View.Details;
			// 
			// columnHeader1
			// 
			this.columnHeader1.Width = 633;
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(8, 8);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(656, 23);
			this.button1.TabIndex = 1;
			this.button1.Text = "    ";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// ReportForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(672, 437);
			this.Controls.Add(this.button1);
			this.Controls.Add(this.listView1);
			this.Name = "ReportForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "ReportForm";
			this.Load += new System.EventHandler(this.ReportForm_Load);
			this.ResumeLayout(false);

		}
		#endregion

		private void ReportForm_Load(object sender, System.EventArgs e)
		{
			button1.Text += "\"" + m_ReportFileName + "\"";
			for(int i=0; i<m_alReport.Count; i++)
			{
				listView1.Items.Add(m_alReport[i].ToString());
			}
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			try
			{
				string AppPath = System.Windows.Forms.Application.StartupPath;
				string ReportFileName = "Report.rpt";
				if(m_ReportFileName != "")
				{
					ReportFileName += m_ReportFileName;
				}
				System.IO.FileStream fs = new System.IO.FileStream(AppPath + @"\Export\" + ReportFileName, System.IO.FileMode.Create);
				System.IO.StreamWriter sw = new System.IO.StreamWriter(fs, System.Text.Encoding.GetEncoding("windows-1251"));

				for(int i=0; i<listView1.Items.Count; i++)
				{
					sw.WriteLine(listView1.Items[i].Text);
				}

				sw.Close();
				fs.Close();

				MessageBox.Show("Ok");
			}
			catch (Exception ex)
			{
				Cerebrum.Windows.Forms.Application.Instance.ProcessException(ex, "");
			}
		}
	}
}
