/******************************************************************************************************

 Cerebrum.Vocabulary.Desktop.dll is part of the Morphology .NET toolkit and contains implementation of
 the toolkit user interface for the OOKBMS Cerebrum desktop environment.

 Copyright (C) 2007-2009 Shuklin Dmitry Evgenievich and Boyko Sergey Vasilievich. All rights reserved.

 The Morphology .NET toolkit is free software; you can redistribute it and/or modify it under the terms 
 of the Microsoft Public License (Ms-PL) as published by the Microsoft.

 This toolkit is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even 
 the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. THE ENTIRE RISK AS TO THE 
 QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU. SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE 
 COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.

 See the Microsoft Public License (Ms-PL) for more details.

 You should have received a copy of the Microsoft Public License (Ms-PL) along with this toolkit;
 if not, the Microsoft Public License (Ms-PL) can be found at 
 http://www.microsoft.com/opensource/licenses.mspx#Ms-PL

 Please see the LICENSE.txt file for the full license.

 For all inquieries and concerns contact an authors at  cerebrum@shdsoft.ru

 This copyright notice MUST APPEAR in all copies of this file!

 //////////////////////////////////////////////////////////////////////////////////////////////////////

  Cerebrum.Vocabulary.Desktop.dll -   Morphology .NET toolkit  
          Cerebrum.

 Copyright (C) 2007-2009       .   .

      ;     / 
      Microsoft Public License (Ms-PL).

     ,    ,   - ;
           .  
          .    
 ,        ,   
 .

      Microsoft Public License (Ms-PL)

      Microsoft Public License (Ms-PL)    ; 
   ,  Microsoft Public License (Ms-PL)      
 http://www.microsoft.com/opensource/licenses.mspx#Ms-PL 

       LICENSE.txt

          : cerebrum@shdsoft.ru
 
          !
 
******************************************************************************************************/

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace Cerebrum.Vocabulary.Desktop
{
	/// <summary>
	/// Summary description for TransformForm.
	/// </summary>
	public class TransformForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Button btnTransform;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.TextBox txtResult;
		private System.Windows.Forms.TextBox txtWordForm;
		private System.Windows.Forms.Button btnMorphAnalysis;
		private System.Windows.Forms.Button btnLemmatize;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public TransformForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		public TransformForm(string WordForm)
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			txtWordForm.Text = WordForm;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.txtWordForm = new System.Windows.Forms.TextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.btnTransform = new System.Windows.Forms.Button();
			this.panel1 = new System.Windows.Forms.Panel();
			this.txtResult = new System.Windows.Forms.TextBox();
			this.btnMorphAnalysis = new System.Windows.Forms.Button();
			this.btnLemmatize = new System.Windows.Forms.Button();
			this.panel1.SuspendLayout();
			this.SuspendLayout();
			// 
			// txtWordForm
			// 
			this.txtWordForm.Location = new System.Drawing.Point(80, 8);
			this.txtWordForm.Name = "txtWordForm";
			this.txtWordForm.TabIndex = 0;
			this.txtWordForm.Text = "";
			this.txtWordForm.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.txtWordForm_KeyPress);
			// 
			// label1
			// 
			this.label1.AutoSize = true;
			this.label1.Location = new System.Drawing.Point(8, 8);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(64, 16);
			this.label1.TabIndex = 1;
			this.label1.Text = "Word Form:";
			// 
			// btnTransform
			// 
			this.btnTransform.Location = new System.Drawing.Point(192, 8);
			this.btnTransform.Name = "btnTransform";
			this.btnTransform.TabIndex = 2;
			this.btnTransform.Text = "Transform";
			this.btnTransform.Click += new System.EventHandler(this.btnTransform_Click);
			// 
			// panel1
			// 
			this.panel1.Controls.Add(this.btnLemmatize);
			this.panel1.Controls.Add(this.btnMorphAnalysis);
			this.panel1.Controls.Add(this.label1);
			this.panel1.Controls.Add(this.btnTransform);
			this.panel1.Controls.Add(this.txtWordForm);
			this.panel1.Dock = System.Windows.Forms.DockStyle.Top;
			this.panel1.Location = new System.Drawing.Point(0, 0);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(472, 40);
			this.panel1.TabIndex = 3;
			// 
			// txtResult
			// 
			this.txtResult.Dock = System.Windows.Forms.DockStyle.Fill;
			this.txtResult.Location = new System.Drawing.Point(0, 40);
			this.txtResult.Multiline = true;
			this.txtResult.Name = "txtResult";
			this.txtResult.ReadOnly = true;
			this.txtResult.ScrollBars = System.Windows.Forms.ScrollBars.Both;
			this.txtResult.Size = new System.Drawing.Size(472, 421);
			this.txtResult.TabIndex = 4;
			this.txtResult.Text = "";
			// 
			// btnMorphAnalysis
			// 
			this.btnMorphAnalysis.Location = new System.Drawing.Point(272, 8);
			this.btnMorphAnalysis.Name = "btnMorphAnalysis";
			this.btnMorphAnalysis.Size = new System.Drawing.Size(104, 23);
			this.btnMorphAnalysis.TabIndex = 3;
			this.btnMorphAnalysis.Text = "Morph Analysis";
			this.btnMorphAnalysis.Click += new System.EventHandler(this.btnMorphAnalysis_Click);
			// 
			// btnLemmatize
			// 
			this.btnLemmatize.Location = new System.Drawing.Point(384, 8);
			this.btnLemmatize.Name = "btnLemmatize";
			this.btnLemmatize.TabIndex = 4;
			this.btnLemmatize.Text = "Lemmatize";
			this.btnLemmatize.Click += new System.EventHandler(this.btnLemmatize_Click);
			// 
			// TransformForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(472, 461);
			this.Controls.Add(this.txtResult);
			this.Controls.Add(this.panel1);
			this.Name = "TransformForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "TransformForm";
			this.panel1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private Cerebrum.Integrator.DomainContext m_DomainContext = null;
		public Cerebrum.Integrator.DomainContext DomainContext
		{
			get
			{
				return m_DomainContext;
			}
			set
			{
				if(m_DomainContext!=value)
				{
					if(m_DomainContext!=null)
					{
						m_DomainContext.Disposing -= new EventHandler(DomainContext_Disposing);
					}
					m_DomainContext = value;
					if(m_DomainContext!=null)
					{
						m_DomainContext.Disposing += new EventHandler(DomainContext_Disposing);
					}
				}
			}
		}

		private void DomainContext_Disposing(object sender, EventArgs e)
		{
			m_DomainContext = null;
			this.Close();
		}

		public Cerebrum.Runtime.ISemiotics m_WMaster = null;

		public void Transform()
		{
			try
			{
				//       .
				System.Collections.Hashtable htStat = new Hashtable();
				//   Transform.
				Cerebrum.Vocabulary.Library.Transform transform = new Cerebrum.Vocabulary.Library.Transform(this.DomainContext, this.m_WMaster);
				//        .
				Cerebrum.Vocabulary.DataModel.WordInfo[] WordInfoList = transform.TransformWord(txtWordForm.Text);
				//      .
				for(int i1=0; i1<WordInfoList.Length; i1++)
				{
					//        .
					Cerebrum.Vocabulary.DataModel.WordInfo wi = (Cerebrum.Vocabulary.DataModel.WordInfo)WordInfoList[i1];
					for(int i2=0; i2<wi.WordFormInfoList.Count; i2++)
					{
						System.Collections.Hashtable htTrans = null;
						Cerebrum.Vocabulary.DataModel.WordFormInfo wfi = (Cerebrum.Vocabulary.DataModel.WordFormInfo)wi.WordFormInfoList[i2];
						//     ...
						if(htStat.ContainsKey(wfi.Statement) == false)
						{
							htTrans = new Hashtable();
							htStat.Add(wfi.Statement, htTrans);
						}
						else
						{
							htTrans = (Hashtable)htStat[wfi.Statement];
						}

						//       .
						System.Collections.ArrayList al = null;
						string Key = "PrefixTransform: " + wi.PrefixTransform + "; EndingTransform: " + wi.EndingTransform;
						if(htTrans.ContainsKey(Key) == false)
						{
							al = new ArrayList();
							htTrans.Add(Key, al);
						}
						else
						{
							al = (ArrayList)htTrans[Key];
						}
						//    .
						al.Add(wfi);
					}
				}
				System.Text.StringBuilder sb = new System.Text.StringBuilder();
				foreach(System.Collections.DictionaryEntry de1 in htStat)
				{
					sb.Append("Statement: " + de1.Key.ToString() + System.Environment.NewLine);
					Hashtable htTrans = (Hashtable)de1.Value;
					foreach(System.Collections.DictionaryEntry de2 in htTrans)
					{
						sb.Append(de2.Key.ToString() + System.Environment.NewLine);
						ArrayList al = (ArrayList)de2.Value;
						for(int i=0; i<al.Count; i++)
						{
							Cerebrum.Vocabulary.DataModel.WordFormInfo wfi = (Cerebrum.Vocabulary.DataModel.WordFormInfo)al[i];
							sb.Append(wfi.Word + "; Specifier: " + wfi.SpecifierName + " (");
							for(int i2=0; i2<wfi.AttributesList.Count; i2++)
							{
								Cerebrum.Vocabulary.DataModel.AttributeInfo ai = (Cerebrum.Vocabulary.DataModel.AttributeInfo)wfi.AttributesList[i2];
								sb.Append(ai.DisplayName);
								if(i2+1 < wfi.AttributesList.Count)
								{
									sb.Append(", ");
								}
							}
							sb.Append(")" + System.Environment.NewLine);
						}
					}
				}
				txtResult.Text = sb.ToString();
			}
			catch(Exception ex)
			{
				MessageBox.Show(ex.StackTrace);
			}
		}

		public void MorphAnalysis()
		{
			try
			{
				txtResult.Text = "";
				Cerebrum.Vocabulary.Library.Transform transform = null;
				transform = new Cerebrum.Vocabulary.Library.Transform(this.DomainContext, this.m_WMaster);
				Cerebrum.Vocabulary.DataModel.WordInfo[] wiWords = transform.MorphologicalAnalysisOfWord(txtWordForm.Text);
				for(int i1=0; i1<wiWords.Length; i1++)
				{
					Cerebrum.Vocabulary.DataModel.WordInfo wi = (Cerebrum.Vocabulary.DataModel.WordInfo)wiWords[i1];
					for(int i3=0; i3<wi.WordFormInfoList.Count; i3++)
					{
						Cerebrum.Vocabulary.DataModel.WordFormInfo wfi = null;
						wfi = (Cerebrum.Vocabulary.DataModel.WordFormInfo)wi.WordFormInfoList[i3];
						txtResult.Text += "Word: " + wfi.Word + "; Specifier=" + wfi.SpecifierName + "; PrefixTransform=" + wi.PrefixTransform + "; EndingTransform=" + wi.EndingTransform + "; Statement=" + wfi.Statement + "; (";
						for(int i2=0; i2<wfi.AttributesList.Count; i2++)
						{
							Cerebrum.Vocabulary.DataModel.AttributeInfo ai = (Cerebrum.Vocabulary.DataModel.AttributeInfo)wfi.AttributesList[i2];
							txtResult.Text += ai.DisplayName + ", ";
						}
						txtResult.Text = txtResult.Text.Substring(0, txtResult.Text.Length - 2) + ")" + System.Environment.NewLine;
					}
				}
			}
			catch(Exception ex)
			{
				MessageBox.Show(ex.StackTrace);
			}
		}

		public void Lemmatize()
		{
			try
			{
				txtResult.Text = "";
				//       .
				System.Collections.Hashtable htStat = new Hashtable();
				//   Transform.
				Cerebrum.Vocabulary.Library.Transform transform = null;
				transform = new Cerebrum.Vocabulary.Library.Transform(this.DomainContext, this.m_WMaster);
				//   .
				Cerebrum.Vocabulary.DataModel.WordInfo[] WordInfoList = transform.Lemmatize(txtWordForm.Text);

				if(WordInfoList != null)
				{
					for(int i1=0; i1<WordInfoList.Length; i1++)
					{
						txtResult.Text += "PrefixTransform: " + WordInfoList[i1].PrefixTransform;
						txtResult.Text += "; EndingTransform: " + WordInfoList[i1].EndingTransform + System.Environment.NewLine;
						string Stat = "";
						for(int i2=0; i2<WordInfoList[i1].WordFormInfoList.Count; i2++)
						{
							Cerebrum.Vocabulary.DataModel.WordFormInfo wfi = null;
							wfi = (Cerebrum.Vocabulary.DataModel.WordFormInfo)WordInfoList[i1].WordFormInfoList[i2];
							if(Stat != wfi.Statement)
							{
								txtResult.Text += "Statement: " + wfi.Statement + System.Environment.NewLine;
								Stat = wfi.Statement;
							}
							txtResult.Text += wfi.Word + System.Environment.NewLine;
						}
					}
				}
				else
				{
					txtResult.Text = "  .";
				}
			}
			catch(Exception ex)
			{
				MessageBox.Show(ex.StackTrace);
			}
		}

		private void btnTransform_Click(object sender, System.EventArgs e)
		{
			Transform();
		}

		private void btnMorphAnalysis_Click(object sender, System.EventArgs e)
		{
			MorphAnalysis();
		}

		private void btnLemmatize_Click(object sender, System.EventArgs e)
		{
			Lemmatize();
		}

		private void txtWordForm_KeyPress(object sender, System.Windows.Forms.KeyPressEventArgs e)
		{
			if(System.Environment.NewLine.IndexOf(e.KeyChar)>=0)
			{
				e.Handled = true;
				btnTransform_Click(sender, e);
			}
		}
	}
}
