/******************************************************************************************************

 Cerebrum.Vocabulary.Desktop.dll is part of the Morphology .NET toolkit and contains implementation of
 the toolkit user interface for the OOKBMS Cerebrum desktop environment.

 Copyright (C) 2007-2009 Shuklin Dmitry Evgenievich and Boyko Sergey Vasilievich. All rights reserved.

 The Morphology .NET toolkit is free software; you can redistribute it and/or modify it under the terms 
 of the Microsoft Public License (Ms-PL) as published by the Microsoft.

 This toolkit is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even 
 the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. THE ENTIRE RISK AS TO THE 
 QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU. SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE 
 COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.

 See the Microsoft Public License (Ms-PL) for more details.

 You should have received a copy of the Microsoft Public License (Ms-PL) along with this toolkit;
 if not, the Microsoft Public License (Ms-PL) can be found at 
 http://www.microsoft.com/opensource/licenses.mspx#Ms-PL

 Please see the LICENSE.txt file for the full license.

 For all inquieries and concerns contact an authors at  cerebrum@shdsoft.ru

 This copyright notice MUST APPEAR in all copies of this file!

 //////////////////////////////////////////////////////////////////////////////////////////////////////

  Cerebrum.Vocabulary.Desktop.dll -   Morphology .NET toolkit  
          Cerebrum.

 Copyright (C) 2007-2009       .   .

      ;     / 
      Microsoft Public License (Ms-PL).

     ,    ,   - ;
           .  
          .    
 ,        ,   
 .

      Microsoft Public License (Ms-PL)

      Microsoft Public License (Ms-PL)    ; 
   ,  Microsoft Public License (Ms-PL)      
 http://www.microsoft.com/opensource/licenses.mspx#Ms-PL 

       LICENSE.txt

          : cerebrum@shdsoft.ru
 
          !
 
******************************************************************************************************/

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace Cerebrum.Vocabulary
{
	/// <summary>
	/// Summary description for WorkInFile.
	/// </summary>
	public class WorkInFile
	{
		public WorkInFile()
		{
			//
			// TODO: Add constructor logic here
			//
		}

		/// <summary>
		///        .
		/// </summary>
		/// <param name="File"></param>
		/// <returns></returns>
		public static Cerebrum.Vocabulary.Desktop.FileInfo LoadFile(string File)
		{
			System.IO.FileStream fs;
			System.IO.StreamReader sr;
			string Text = "";
			Cerebrum.Vocabulary.Desktop.FileInfo fi = null;

			try
			{
				//  .
				fs = new System.IO.FileStream(File, System.IO.FileMode.Open);
				sr = new System.IO.StreamReader(fs, System.Text.Encoding.GetEncoding("windows-1251"));
				Text = sr.ReadToEnd();
				sr.Close();
				fs.Close();

				//    .
				int n = File.LastIndexOf(@"\");
				fi = new Cerebrum.Vocabulary.Desktop.FileInfo();
				fi.FileName = File.Substring(n + 1);
				fi.FileText = Text;
			}
			catch (Exception ex)
			{
				Cerebrum.Windows.Forms.Application.Instance.ProcessException(ex, "");
			}
			return fi;
		}

		/// <summary>
		///        .
		/// </summary>
		/// <param name="DefaultExt"></param>
		/// <param name="Filter"></param>
		/// <returns></returns>
		public static Cerebrum.Vocabulary.Desktop.FileInfo LoadFile(string DefaultExt, string Filter)
		{
			OpenFileDialog dlg;
			Cerebrum.Vocabulary.Desktop.FileInfo fi = null;

			try
			{
				dlg = new OpenFileDialog();
				dlg.DefaultExt = DefaultExt;
				dlg.Filter = Filter;
				if (dlg.ShowDialog() == DialogResult.OK)
				{
					fi = LoadFile(dlg.FileName);
				}
			}
			catch (Exception ex)
			{
				Cerebrum.Windows.Forms.Application.Instance.ProcessException(ex, "");
			}
			return fi;
		}

		public static System.Collections.Hashtable LoadINI(string DefaultExt, string Filter)
		{
			int n2;
			char chEnter = Convert.ToChar(13);
			char chTen = Convert.ToChar(10);
			System.Text.RegularExpressions.Regex rx = new System.Text.RegularExpressions.Regex(@"^\[.*\]$");
			System.Collections.Hashtable htGroups = new Hashtable();
			string GroupName = "";

			try
			{
				Cerebrum.Vocabulary.Desktop.FileInfo fi = LoadFile(DefaultExt, Filter);
				if(fi != null)
				{
					for (int n1 = 0; n1 < fi.FileText.Length; n1++)
					{
						n2 = fi.FileText.IndexOf(chEnter, n1);
						if (n2 == -1)
						{
							n2 = fi.FileText.IndexOf(chTen, n1);
						}
						if (n2 != -1)
						{
							//    .
							string sRow = fi.FileText.Substring(n1, n2 - n1);
							n1 = n2 + 1;

							System.Text.RegularExpressions.Match m = rx.Match(sRow);
							if(m.Success == true)
							{
								GroupName = sRow;
								if(htGroups.ContainsKey(GroupName) == false)
								{
									ArrayList alWords = new ArrayList();
									htGroups.Add(GroupName, alWords);
								}
							}
							else
							{
								ArrayList alWords = (ArrayList)htGroups[GroupName];
								alWords.Add(sRow);
							}
						}
					}
				}
			}
			catch (Exception ex)
			{
				Cerebrum.Windows.Forms.Application.Instance.ProcessException(ex, "");
			}
			return htGroups;
		}

		public static string LoadFileText(string DefaultExt, string Filter)
		{
			OpenFileDialog dlg;

			dlg = new OpenFileDialog();
			dlg.DefaultExt = DefaultExt;
			dlg.Filter = Filter;
			if (dlg.ShowDialog() == DialogResult.OK)
			{

				//  .
				using(System.IO.FileStream fs = new System.IO.FileStream(dlg.FileName, System.IO.FileMode.Open))
				{
					using(System.IO.StreamReader sr = new System.IO.StreamReader(fs, System.Text.Encoding.Default))
					{
						return sr.ReadToEnd();
					}
				}
			}
			return null;
		}

	}
}
