/******************************************************************************************************

 Cerebrum.Vocabulary.Library.Test.exe - Example of using Cerebrum. Vocabulary. Library.dll  API  without 
 use of the OOKBMS Cerebrum desktop environment.

 Copyright (C) 2007-2009 Shuklin Dmitry Evgenievich and Boyko Sergey Vasilievich. All rights reserved.

 The Morphology .NET toolkit is free software; you can redistribute it and/or modify it under the terms 
 of the Microsoft Public License (Ms-PL) as published by the Microsoft.

 This toolkit is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even 
 the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. THE ENTIRE RISK AS TO THE 
 QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU. SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE 
 COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.

 See the Microsoft Public License (Ms-PL) for more details.

 You should have received a copy of the Microsoft Public License (Ms-PL) along with this toolkit;
 if not, the Microsoft Public License (Ms-PL) can be found at 
 http://www.microsoft.com/opensource/licenses.mspx#Ms-PL

 Please see the LICENSE.txt file for the full license.

 For all inquieries and concerns contact an authors at  cerebrum@shdsoft.ru

 This copyright notice MUST APPEAR in all copies of this file!

 //////////////////////////////////////////////////////////////////////////////////////////////////////

 Cerebrum.Vocabulary.Library.Test.exe -    Cerebrum.Vocabulary.Library.dll 
  desktop   Cerebrum.
 
 Copyright (C) 2007-2009       .   .

      ;     / 
      Microsoft Public License (Ms-PL).

     ,    ,   - ;
           .  
          .    
 ,        ,   
 .

      Microsoft Public License (Ms-PL)

      Microsoft Public License (Ms-PL)    ; 
   ,  Microsoft Public License (Ms-PL)      
 http://www.microsoft.com/opensource/licenses.mspx#Ms-PL 

       LICENSE.txt

          : cerebrum@shdsoft.ru
 
          !
 
******************************************************************************************************/

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace Cerebrum.Vocabulary.Library.Test
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Cerebrum.Vocabulary.Library.Application app;
		private System.Windows.Forms.TextBox textBox1;
		private System.Windows.Forms.TextBox textBox2;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.Button btnOpenDB;
		private System.Windows.Forms.Button btnCloseDB;
		private System.Windows.Forms.Button btnTransformWord;
		private System.Windows.Forms.Button btnMorphAnalysis;
		private System.Windows.Forms.Button btnSpellChecker;
		private System.Windows.Forms.Button btnLemmatize;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			app = null;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(app != null)
				{
					app.Shutdown();
					app.Dispose();
					app = null;
				}
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.textBox1 = new System.Windows.Forms.TextBox();
			this.textBox2 = new System.Windows.Forms.TextBox();
			this.btnTransformWord = new System.Windows.Forms.Button();
			this.btnSpellChecker = new System.Windows.Forms.Button();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.btnLemmatize = new System.Windows.Forms.Button();
			this.btnMorphAnalysis = new System.Windows.Forms.Button();
			this.btnOpenDB = new System.Windows.Forms.Button();
			this.btnCloseDB = new System.Windows.Forms.Button();
			this.groupBox1.SuspendLayout();
			this.SuspendLayout();
			// 
			// textBox1
			// 
			this.textBox1.Enabled = false;
			this.textBox1.Location = new System.Drawing.Point(8, 16);
			this.textBox1.Name = "textBox1";
			this.textBox1.Size = new System.Drawing.Size(288, 20);
			this.textBox1.TabIndex = 0;
			this.textBox1.Text = "";
			// 
			// textBox2
			// 
			this.textBox2.Enabled = false;
			this.textBox2.Location = new System.Drawing.Point(8, 40);
			this.textBox2.Multiline = true;
			this.textBox2.Name = "textBox2";
			this.textBox2.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
			this.textBox2.Size = new System.Drawing.Size(904, 328);
			this.textBox2.TabIndex = 1;
			this.textBox2.Text = "";
			// 
			// btnTransformWord
			// 
			this.btnTransformWord.Enabled = false;
			this.btnTransformWord.Location = new System.Drawing.Point(304, 16);
			this.btnTransformWord.Name = "btnTransformWord";
			this.btnTransformWord.Size = new System.Drawing.Size(104, 23);
			this.btnTransformWord.TabIndex = 2;
			this.btnTransformWord.Text = "Transform word";
			this.btnTransformWord.Click += new System.EventHandler(this.btnTransformWord_Click);
			// 
			// btnSpellChecker
			// 
			this.btnSpellChecker.Enabled = false;
			this.btnSpellChecker.Location = new System.Drawing.Point(608, 16);
			this.btnSpellChecker.Name = "btnSpellChecker";
			this.btnSpellChecker.Size = new System.Drawing.Size(96, 23);
			this.btnSpellChecker.TabIndex = 4;
			this.btnSpellChecker.Text = "Spell Checker";
			this.btnSpellChecker.Click += new System.EventHandler(this.btnSpellChecker_Click);
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.Add(this.btnLemmatize);
			this.groupBox1.Controls.Add(this.btnMorphAnalysis);
			this.groupBox1.Controls.Add(this.btnSpellChecker);
			this.groupBox1.Controls.Add(this.textBox2);
			this.groupBox1.Controls.Add(this.btnTransformWord);
			this.groupBox1.Controls.Add(this.textBox1);
			this.groupBox1.Location = new System.Drawing.Point(8, 40);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(920, 376);
			this.groupBox1.TabIndex = 5;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Cerebrum.Vocabulary.Library.Transform";
			// 
			// btnLemmatize
			// 
			this.btnLemmatize.Enabled = false;
			this.btnLemmatize.Location = new System.Drawing.Point(712, 16);
			this.btnLemmatize.Name = "btnLemmatize";
			this.btnLemmatize.TabIndex = 6;
			this.btnLemmatize.Text = "Lemmatize";
			this.btnLemmatize.Click += new System.EventHandler(this.btnLemmatize_Click);
			// 
			// btnMorphAnalysis
			// 
			this.btnMorphAnalysis.Enabled = false;
			this.btnMorphAnalysis.Location = new System.Drawing.Point(416, 16);
			this.btnMorphAnalysis.Name = "btnMorphAnalysis";
			this.btnMorphAnalysis.Size = new System.Drawing.Size(184, 23);
			this.btnMorphAnalysis.TabIndex = 5;
			this.btnMorphAnalysis.Text = "Morphological Analysis Of Word";
			this.btnMorphAnalysis.Click += new System.EventHandler(this.btnMorphAnalysis_Click);
			// 
			// btnOpenDB
			// 
			this.btnOpenDB.Location = new System.Drawing.Point(8, 8);
			this.btnOpenDB.Name = "btnOpenDB";
			this.btnOpenDB.Size = new System.Drawing.Size(104, 23);
			this.btnOpenDB.TabIndex = 6;
			this.btnOpenDB.Text = "Open Database";
			this.btnOpenDB.Click += new System.EventHandler(this.btnOpenDB_Click);
			// 
			// btnCloseDB
			// 
			this.btnCloseDB.Enabled = false;
			this.btnCloseDB.Location = new System.Drawing.Point(120, 8);
			this.btnCloseDB.Name = "btnCloseDB";
			this.btnCloseDB.Size = new System.Drawing.Size(104, 23);
			this.btnCloseDB.TabIndex = 7;
			this.btnCloseDB.Text = "Close Database";
			this.btnCloseDB.Click += new System.EventHandler(this.btnCloseDB_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(936, 421);
			this.Controls.Add(this.btnCloseDB);
			this.Controls.Add(this.btnOpenDB);
			this.Controls.Add(this.groupBox1);
			this.Name = "Form1";
			this.Text = "Test";
			this.Load += new System.EventHandler(this.Form1_Load);
			this.groupBox1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			System.Windows.Forms.Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
		}

		private void btnOpenDB_Click(object sender, System.EventArgs e)
		{
			try
			{
				OpenFileDialog dlg = new OpenFileDialog();
				dlg.DefaultExt = "*.vnn";
				dlg.Filter = "*.vnn|*.vnn|*.bin|*.bin|*.*|*.*";
				if (dlg.ShowDialog() == DialogResult.OK)
				{
					app = new Application(dlg.FileName);

					textBox1.Enabled = true;
					textBox2.Enabled = true;
					btnOpenDB.Enabled = false;
					btnCloseDB.Enabled = true;
					btnTransformWord.Enabled = true;
					btnMorphAnalysis.Enabled = true;
					btnSpellChecker.Enabled = true;
					btnLemmatize.Enabled = true;
				}
			}
			catch(Exception ex)
			{
				MessageBox.Show(ex.StackTrace);
			}
		}

		private void btnCloseDB_Click(object sender, System.EventArgs e)
		{
			try
			{
				if(app != null)
				{
					app.Shutdown();
					app.Dispose();
					app = null;

					textBox1.Enabled = false;
					textBox2.Enabled = false;
					btnOpenDB.Enabled = true;
					btnCloseDB.Enabled = false;
					btnTransformWord.Enabled = false;
					btnMorphAnalysis.Enabled = false;
					btnSpellChecker.Enabled = false;
					btnLemmatize.Enabled = false;
				}
			}
			catch(Exception ex)
			{
				MessageBox.Show(ex.StackTrace);
			}
		}

		private void btnTransformWord_Click(object sender, System.EventArgs e)
		{
			try
			{
				if(app != null)
				{
					//       .
					System.Collections.Hashtable htStat = new Hashtable();
					//   Transform.
					Cerebrum.Vocabulary.Library.Transform transform = new Transform(app.MasterContext, app.m_WMaster);
					//        .
					Cerebrum.Vocabulary.DataModel.WordInfo[] WordInfoList = transform.TransformWord(textBox1.Text);

					//      .
					for(int i1=0; i1<WordInfoList.Length; i1++)
					{
						//        .
						Cerebrum.Vocabulary.DataModel.WordInfo wi = (Cerebrum.Vocabulary.DataModel.WordInfo)WordInfoList[i1];
						for(int i2=0; i2<wi.WordFormInfoList.Count; i2++)
						{
							System.Collections.Hashtable htTrans = null;
							Cerebrum.Vocabulary.DataModel.WordFormInfo wfi = (Cerebrum.Vocabulary.DataModel.WordFormInfo)wi.WordFormInfoList[i2];
							//     ...
							if(htStat.ContainsKey(wfi.Statement) == false)
							{
								htTrans = new Hashtable();
								htStat.Add(wfi.Statement, htTrans);
							}
							else
							{
								htTrans = (Hashtable)htStat[wfi.Statement];
							}

							//       .
							System.Collections.ArrayList al = null;
							string Key = "PrefixTransform: " + wi.PrefixTransform + "; EndingTransform: " + wi.EndingTransform;
							if(htTrans.ContainsKey(Key) == false)
							{
								al = new ArrayList();
								htTrans.Add(Key, al);
							}
							else
							{
								al = (ArrayList)htTrans[Key];
							}
							//    .
							al.Add(wfi);
						}
					}
					System.Text.StringBuilder sb = new System.Text.StringBuilder();
					foreach(System.Collections.DictionaryEntry de1 in htStat)
					{
						sb.Append("Statement: " + de1.Key.ToString() + System.Environment.NewLine);
						Hashtable htTrans = (Hashtable)de1.Value;
						foreach(System.Collections.DictionaryEntry de2 in htTrans)
						{
							sb.Append(de2.Key.ToString() + System.Environment.NewLine);
							ArrayList al = (ArrayList)de2.Value;
							for(int i=0; i<al.Count; i++)
							{
								Cerebrum.Vocabulary.DataModel.WordFormInfo wfi = (Cerebrum.Vocabulary.DataModel.WordFormInfo)al[i];
								sb.Append(wfi.Word + "; Specifier: " + wfi.SpecifierName + " (");
								for(int i2=0; i2<wfi.AttributesList.Count; i2++)
								{
									Cerebrum.Vocabulary.DataModel.AttributeInfo ai = (Cerebrum.Vocabulary.DataModel.AttributeInfo)wfi.AttributesList[i2];
									sb.Append(ai.DisplayName);
									if(i2+1 < wfi.AttributesList.Count)
									{
										sb.Append(", ");
									}
								}
								sb.Append(")" + System.Environment.NewLine);
							}
						}
					}
					textBox2.Text = sb.ToString();
				}
			}
			catch(Exception ex)
			{
				MessageBox.Show(ex.StackTrace);
			}
		}

		private void btnMorphAnalysis_Click(object sender, System.EventArgs e)
		{
			try
			{
				if(app != null)
				{
					textBox2.Text = "";
					Cerebrum.Vocabulary.Library.Transform transform = new Transform(app.MasterContext, app.m_WMaster);
					Cerebrum.Vocabulary.DataModel.WordInfo[] wiWords = transform.MorphologicalAnalysisOfWord(textBox1.Text);
					for(int i1=0; i1<wiWords.Length; i1++)
					{
						Cerebrum.Vocabulary.DataModel.WordInfo wi = (Cerebrum.Vocabulary.DataModel.WordInfo)wiWords[i1];
						for(int i3=0; i3<wi.WordFormInfoList.Count; i3++)
						{
							Cerebrum.Vocabulary.DataModel.WordFormInfo wfi = null;
							wfi = (Cerebrum.Vocabulary.DataModel.WordFormInfo)wi.WordFormInfoList[i3];
							textBox2.Text += "Word: " + wfi.Word + "; Specifier=" + wfi.SpecifierName + "; PrefixTransform=" + wi.PrefixTransform + "; EndingTransform=" + wi.EndingTransform + "; Statement=" + wfi.Statement + "; (";
							for(int i2=0; i2<wfi.AttributesList.Count; i2++)
							{
								Cerebrum.Vocabulary.DataModel.AttributeInfo ai = (Cerebrum.Vocabulary.DataModel.AttributeInfo)wfi.AttributesList[i2];
								textBox2.Text += ai.DisplayName + ", ";
							}
							textBox2.Text = textBox2.Text.Substring(0, textBox2.Text.Length - 2) + ")" + System.Environment.NewLine;
						}
					}
				}
			}
			catch(Exception ex)
			{
				MessageBox.Show(ex.StackTrace);
			}
		}

		private void btnSpellChecker_Click(object sender, System.EventArgs e)
		{
			try
			{
				Cerebrum.Vocabulary.Library.Transform trans = new Transform(app.MasterContext, app.m_WMaster);
				MessageBox.Show(trans.WordSpellCheck(textBox1.Text).ToString());
			}
			catch(Exception ex)
			{
				MessageBox.Show(ex.StackTrace);
			}
		}

		private void btnLemmatize_Click(object sender, System.EventArgs e)
		{
			try
			{
				textBox2.Text = "";
				if(app != null)
				{
					//       .
					System.Collections.Hashtable htStat = new Hashtable();
					//   Transform.
					Cerebrum.Vocabulary.Library.Transform transform = new Transform(app.MasterContext, app.m_WMaster);
					//   .
					Cerebrum.Vocabulary.DataModel.WordInfo[] WordInfoList = transform.Lemmatize(textBox1.Text);

					if(WordInfoList != null)
					{
						for(int i1=0; i1<WordInfoList.Length; i1++)
						{
							textBox2.Text += "PrefixTransform: " + WordInfoList[i1].PrefixTransform;
							textBox2.Text += "; EndingTransform: " + WordInfoList[i1].EndingTransform + System.Environment.NewLine;
							string Stat = "";
							for(int i2=0; i2<WordInfoList[i1].WordFormInfoList.Count; i2++)
							{
								Cerebrum.Vocabulary.DataModel.WordFormInfo wfi = null;
								wfi = (Cerebrum.Vocabulary.DataModel.WordFormInfo)WordInfoList[i1].WordFormInfoList[i2];
								if(Stat != wfi.Statement)
								{
									textBox2.Text += "Statement: " + wfi.Statement + System.Environment.NewLine;
									Stat = wfi.Statement;
								}
								textBox2.Text += wfi.Word + System.Environment.NewLine;
							}
						}
					}
					else
					{
						textBox2.Text = "  .";
					}
				}
			}
			catch(Exception ex)
			{
				MessageBox.Show(ex.StackTrace);
			}
		}
	}
}
