/******************************************************************************************************

 Cerebrum.Vocabulary.Library.dll - contains implementation of the application program interface to the 
 morphological database.

 Copyright (C) 2007-2009 Shuklin Dmitry Evgenievich and Boyko Sergey Vasilievich. All rights reserved.

 The Morphology .NET toolkit is free software; you can redistribute it and/or modify it under the terms 
 of the Microsoft Public License (Ms-PL) as published by the Microsoft.

 This toolkit is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even 
 the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. THE ENTIRE RISK AS TO THE 
 QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU. SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE 
 COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.

 See the Microsoft Public License (Ms-PL) for more details.

 You should have received a copy of the Microsoft Public License (Ms-PL) along with this toolkit;
 if not, the Microsoft Public License (Ms-PL) can be found at 
 http://www.microsoft.com/opensource/licenses.mspx#Ms-PL

 Please see the LICENSE.txt file for the full license.

 For all inquieries and concerns contact an authors at  cerebrum@shdsoft.ru

 This copyright notice MUST APPEAR in all copies of this file!

 //////////////////////////////////////////////////////////////////////////////////////////////////////

 Cerebrum.Vocabulary.Library.dll -        .
 
 Copyright (C) 2007-2009       .   .

      ;     / 
      Microsoft Public License (Ms-PL).

     ,    ,   - ;
           .  
          .    
 ,        ,   
 .

      Microsoft Public License (Ms-PL)

      Microsoft Public License (Ms-PL)    ; 
   ,  Microsoft Public License (Ms-PL)      
 http://www.microsoft.com/opensource/licenses.mspx#Ms-PL 

       LICENSE.txt

          : cerebrum@shdsoft.ru
 
          !
 
******************************************************************************************************/

using System;

namespace Cerebrum.Vocabulary.Desktop
{
	/// <summary>
	/// Summary description for Utilites.
	/// </summary>
	public class Utilites
	{
		private Utilites()
		{
			//
			// TODO: Add constructor logic here
			//
		}

		public static Cerebrum.IComposite AttachString(Cerebrum.Runtime.ISemiotics wmaster, string text, bool readOnly)
		{
			Cerebrum.ObjectHandle [] ohs = wmaster.ParseToken(text, readOnly);
			if(ohs!=null && ohs.Length > 0)
			{
				return wmaster.AttachConnector(ohs[0]);
			}
			return null;
		}
	
		public static Cerebrum.IComposite AttachStringQuoted(Cerebrum.Runtime.ISemiotics wmaster, string text, bool readOnly)
		{
			string token;
			/*if(wmaster is Cerebrum.Runtime.LFacade)
			{*/
			token = text;
			/*}
			else
			{
				token = "\"" + text.Replace("\"", "\\\"") + "\"";
			}*/
			Cerebrum.ObjectHandle [] ohs = wmaster.ParseToken(token, readOnly);
			if(ohs!=null && ohs.Length > 0)
			{
				return wmaster.AttachConnector(ohs[0]);
			}
			return null;
		}

		public static System.Data.DataTable TableFromView(System.ComponentModel.ITypedList view)
		{
			System.Data.DataTable table = new System.Data.DataTable();
			System.ComponentModel.IBindingList list = view as System.ComponentModel.IBindingList;
			System.ComponentModel.PropertyDescriptorCollection props = view.GetItemProperties(null);
			for(int c = 0; c < props.Count; c++)
			{
				System.ComponentModel.PropertyDescriptor prp = props[c];
				System.Data.DataColumn column = new System.Data.DataColumn(prp.Name, prp.PropertyType);
				table.Columns.Add(column);
			}
			for(int r = 0; r < list.Count; r++)
			{
				object item = list[r];
				System.Data.DataRow row = table.NewRow();
				for(int c = 0; c < props.Count; c++)
				{
					System.ComponentModel.PropertyDescriptor prp = props[c];
					row[prp.Name] = prp.GetValue(item);
				}
				table.Rows.Add(row);
			}
			table.AcceptChanges();
			return table;
		}
		public static void UpdateViewFromTable(Cerebrum.Data.TableView view, System.Data.DataTable table)
		{
			System.ComponentModel.PropertyDescriptorCollection props = view.GetItemProperties(null);
			for(int r = 0; r < table.Rows.Count; r++)
			{
				System.Data.DataRow row = table.Rows[r];
				Cerebrum.ObjectHandle handle = (Cerebrum.ObjectHandle)row["ObjectHandle"];
				Cerebrum.Data.ComponentItemView item = view.CreateItemViewByObjectHandle(handle);
				for(int c = 0; c < props.Count; c++)
				{
					System.ComponentModel.PropertyDescriptor prp = props[c];
					if(prp.PropertyType!=typeof(Cerebrum.ObjectHandle))
					{
						prp.SetValue(item, row[prp.Name]);
					}
				}
			}
			table.AcceptChanges();
		}

		public static string FilterNodeText(string path)
		{
			//         .
			string StrLine = path.Replace("\r", "").Replace("\n", "");
			//    .
			char[] arChar = StrLine.ToCharArray();
			// 
			StrLine = "";
			//      .
			for(int i=0; i<arChar.Length; i++)
			{
				//    ...
				if(arChar[i] == '(')
				{
					//     ...
					if((arChar[i+1] != ' ')&&(arChar[i+1] != '('))
					{
						//      .
						StrLine += arChar[i+1].ToString();
						//    2.
						i += 2;
					}
					else if(arChar[i+1] == ' ')
					{
						//     .
						StrLine += arChar[i].ToString();
					}
				}
				else
				{
					//     .
					StrLine += arChar[i].ToString();
				}
			}
			//    .
			StrLine = StrLine.Replace(" ", "");
			//  .
			return StrLine;
		}
	}
}

